#include <stdio.h>
#include "Contatore.h"

/* Questa funzione stampa a video il valore di una variabile di tipo "StatoContatore" */
void visualizzaStato(StatoContatore stato)
{
	if(stato==NO_ERROR) printf("NO ERROR\n");
	else if(stato==BAD_MAX_VAL) printf("BAD_MAX_VAL\n");
	else if(stato==OVERFLOW) printf("OVERFLOW\n");
	else printf("Codice d'errore non riconosciuto\n");
}



void setMaxVal(Contatore *c, int val)
{
	if(val<=0) (*c).stato = BAD_MAX_VAL;
	else (*c).valore_max = val;
}

void azzera(Contatore *c)
{
	(*c).valore = 0;
	(*c).stato = NO_ERROR;
}

void inizializza(Contatore *c,int val)
{
	(*c).valore = 0;
	(*c).stato = NO_ERROR;
	setMaxVal(c,val);
}

void incrementa(Contatore *c)
{
	if((*c).valore >= (*c).valore_max)
	{
		(*c).stato = OVERFLOW;
		(*c).valore = 0;
	}
	else (*c).valore++;
}

void visualizza(Contatore c)
{
	if(!isError(c)) printf("Val act = %d, val max = %d\n", c.valore, c.valore_max);
	else
	{
		printf("Errore: ");
		visualizzaStato(c.stato);
	}
}

int leggi(Contatore c){
	return c.valore;
}

StatoContatore isError(Contatore c){
	return c.stato;
}



